/*******************************************************************************
* Copyright 2008 Seapine Software, Inc. All rights reserved.
*
* IMPORTANT:  This Software is supplied to you by Seapine Software, Inc. (Seapine)
* in consideration of your agreement to the following terms, and your use, installation,
* modification or redistribution of this Software constitutes acceptance of these terms.
* If you do not agree with these terms, please do not use, install, modify or redistribute
* this Software.
*
* In consideration of your agreement to abide by the following terms, and subject to these
* terms, Seapine grants you a personal, non-exclusive license, under Seapine copyrights in
* this original Seapine software (the Software), to use, reproduce, modify and redistribute
* the Software, with or without modifications, in source and/or binary forms; provided that
* if you redistribute the Software in its entirety and without modifications, you must retain
* this notice and the following text and disclaimers in all such redistributions of the Software.
* Neither the name, trademarks, service marks or logos of Seapine, Inc. may be used to endorse
* or promote products derived from the Software without specific prior written permission from
* Seapine.  Except as expressly stated in this notice, no other rights or licenses, express or
* implied, are granted by Seapine herein, including but not limited to any patent rights that
* may be infringed by your derivative works or by other works in which the Software may be
* incorporated.
*
* The Software is provided by Seapine on an "AS IS" basis.  SEAPINE MAKES NO WARRANTIES,
* EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION THE IMPLIED WARRANTIES OF NON-INFRINGEMENT,
* MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE, REGARDING THE SOFTWARE OR ITS USE AND
* OPERATION ALONE OR IN COMBINATION WITH YOUR PRODUCTS.
*
* IN NO EVENT SHALL SEAPINE BE LIABLE FOR ANY SPECIAL, INDIRECT, INCIDENTAL OR CONSEQUENTIAL
* DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
* LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) ARISING IN ANY WAY OUT OF THE USE,
* REPRODUCTION, MODIFICATION AND/OR DISTRIBUTION OF THE SOFTWARE, HOWEVER CAUSED AND WHETHER
* UNDER THEORY OF CONTRACT, TORT (INCLUDING NEGLIGENCE), STRICT LIABILITY OR OTHERWISE, EVEN
* IF SEAPINE HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
******************************************************************************/

/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package generatetruns;

/**
 *
 * @author cremerf
 */

//import java.net.MalformedURLException;
//import java.io.
import java.rmi.RemoteException;
import java.util.logging.Level;
import java.util.logging.Logger;
import testtrack_Interface.*;
//import java.net.URL;
import javax.xml.rpc.Stub;

public class Main {

    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) {
        // TODO code application logic here
        //Before we do anything, let's make sure we have the nescessary arguments
        if (args.length == 4)
        {
            //Define variables for app
            //TestTrack SOAP connection vars - passed as arguments
            String ttServer;
            String ttUser;
            String ttPassword;
            String createLink;

            //We'll get this from the environment variables DNUM and PROJNAME
            String ttDefNum;
            String ttProject;

            //This value is hard coded, but we could open defect and look for value in custom field
            String ttTestRunSet;

            //other variables for processing
            long ttCookie;
            long DNum = 0;

            //Set the variables to the corresponding arguments
            ttServer = args[0];
            ttUser = args[1];
            ttPassword = args[2];
            createLink = args[3];

            ttProject = System.getenv("PROJNAME");
            ttDefNum = System.getenv("DNUM");
            //For debugging we can't get env vars, so we'll pass them as args as well
            //If you do this, make sure you change the number of args in the if statement to 6
            // ttProject = args[4];
            // ttDefNum = args[5];

            ttTestRunSet = "Alpha 1";
            try
            {
                DNum = Integer.parseInt(ttDefNum);
            }
            catch (Exception fcc)
            {
                System.out.print(fcc.getMessage());
                System.exit(0);
            }
            try
            {
                //Define soap cgi object
                TtsoapcgiPortType_Stub ttSoap = (TtsoapcgiPortType_Stub)(new Ttsoapcgi_Impl().getTtsoapcgi());
                //Set the soap cgi URL
                ttSoap._setProperty(javax.xml.rpc.Stub.ENDPOINT_ADDRESS_PROPERTY, ttServer);
                //Get lists of projects for user and select one we want
                CProject ttCProject = new CProject(); 
                CProject[] ttCProjects = ttSoap.getProjectList(ttUser, ttPassword);
                for (int i=0;i < ttCProjects.length; i++)
                {
                    if (ttCProjects[i].getDatabase().getName().equals(ttProject))
                    {
                        ttCProject = ttCProjects[i];
                    
                    }
                }
                if (ttCProject != null)
                {
                    //if we found project for user, lets log in
                    ttCookie = ttSoap.projectLogon(ttCProject,ttUser,ttPassword);
                    CDefect ttDefect = new CDefect();
                    //Get defect object that cuased this executable to run
                    ttDefect = ttSoap.getDefect(ttCookie, DNum, "", false);
                    //Get links from defect to see if there is a test case
                    CLink[] ttDLinks = ttSoap.getLinksForDefect(ttCookie, ttDefect.getRecordid());
                    //Loop through each link
                    for (int i = 0; i < ttDLinks.length; i++)
                    {
                        //Loop through each member of each link
                        for (int j = 0; j < ttDLinks[i].getChildList().length; j++)
                        {
                            //If link member is a test case, then we want it

                            if (ttDLinks[i].getChildList()[j].getTablename().equals("Test Case"))
                            {
                                CLinkedItem ttLink = ttDLinks[i].getChildList()[j];
                                //Get test case object
                                CTestCase ttTCase = ttSoap.getTestCase(ttCookie, Integer.parseInt(ttLink.getNumber()), "", false);
                                //before we can generate the test run for the test case, we need
                                //to build our test runs.  We'll use all variants defined in the test case
                                CTestRunVariantField[] ttRunVariants = new CTestRunVariantField[ttTCase.getTestVariants().length];
                                for (int k = 0; k < ttTCase.getTestVariants().length; k++)
                                {
                                    //Need to make sure we only look at the "Included" variants, and not the "Excluded" ones.
                                    if (ttTCase.getTestVariants()[k].getType().equals("Included"))
                                    {
                                        CFieldValue[] tvVal = new CFieldValue[ttTCase.getTestVariants()[k].getValues().length];
                                        //Go through each value in this variant 
                                        for (int l = 0; l < ttTCase.getTestVariants()[k].getValues().length; l++)
                                        {
                                            tvVal[l] = new CFieldValue();
                                            tvVal[l].setValue(ttTCase.getTestVariants()[k].getValues()[l].getValue());
                                        }

                                        ttRunVariants[k] = new CTestRunVariantField();
                                        ttRunVariants[k].setName(ttTCase.getTestVariants()[k].getName());
                                        ttRunVariants[k].setValues(tvVal);
                                    }
                                }
                                //Now we can generate the test run 

                                CItemToTrack[] ttRuns = ttSoap.generateTestRuns(ttCookie, ttTCase.getRecordid(), ttRunVariants, ttTestRunSet);
                                //If yes to create link, then do it
                                if (createLink.equals("true"))
                                {
                                    //Define the parent - Defect
                                    CLinkedItem parentLink = new CLinkedItem();
                                    parentLink.setEntityType(0x64666374);
                                    parentLink.setEntityID(ttDefect.getRecordid());
                                    parentLink.setNumber(ttDefNum);
                                    parentLink.setTablename("Defect");
                                    //For each test run created add to link
                                    CLinkedItem[] alinks = new CLinkedItem[ttRuns.length];
                                    for (int m = 0; m <ttRuns.length ; m++)
                                    {
                                        //get the test run object
                                        CTestRun ttRun = ttSoap.getTestRunByRecordID(ttCookie, ttRuns[m].getRecordid(), false);
                                        //Define the child - TestRun
                                        alinks[m] = new CLinkedItem();
                                        alinks[m].setEntityType(0x64666374);
                                        alinks[m].setEntityID(ttRun.getRecordid());
                                        alinks[m].setNumber(String.valueOf(ttRun.getTestrunnumber()));
                                        alinks[m].setTablename("Test Run");
                                        
                                    }
                                    //Create the link
                                    CLink link = new CLink();
                                    link.setLinkDefinitionName("Parent/Child");
                                    link.setLinkparent(parentLink);
                                    link.setChildList(alinks);
                                    //add the link
                                    ttSoap.addLink(ttCookie, link);
                                }
                            }
                        }
                    }
                    ttSoap.databaseLogoff(ttCookie);
                }
            }
            catch (Exception fcc)
            {
                
                System.out.println(fcc.getLocalizedMessage());
                System.out.println(fcc.getMessage());
            }  
            
            
            
        }
    }
        /*
         * 
         

              
                
                if (ttCProject != null)
                {
                    try
                    {
                        //if we found project for user, lets log in
                        ttCookie = ttSoap.ProjectLogon(ttCProject, ttUser, ttPassword);
                       
                        
                        ttSoap.DatabaseLogoff(ttCookie);
                    }
                    catch (Exception fcc)
                    {
                        Logger.log("An error was encountered while processing the generation of test runs:");
                        Logger.log(fcc.Message);
                        Environment.Exit(0);
                    }
                }
            }
            else
            {
                Logger.log("Incorrect number of parameters passed");
                Logger.log(args.Length.ToString() + " parameter(s) were passed");
                Environment.Exit(0);
            }
         * 
         * 
         * 
         * 
         * *
        
        try 
        {
           // Ttsoapcgi ttsoapcgi = new Ttsoapcgi_Impl();
           // TtsoapcgiPortType _ttsoapcgi = ttsoapcgi.getTtsoapcgi();
            TtsoapcgiPortType_Stub test = createProxy(); 
            
            //the _ttsoapcgi is what we'll use to make all the calls
            String ttSOAP = "http://127.0.0.1:80/scripts/ttsoapcgi.exe";
           
            
            test._setProperty(javax.xml.rpc.Stub.ENDPOINT_ADDRESS_PROPERTY, ttSOAP);
                     
	    
            CProject ttProject = new CProject(); 
            CProject[] ttProjects = test.getProjectList("Administrator", "password");
            for (int i=0;i < ttProjects.length; i++)
            {
                if (ttProjects[i].getDatabase().getName().equals("Training Demo Project"))
                {
                    ttProject = ttProjects[i];
                    
                }
            }
            long ttCookie = test.projectLogon(ttProject,"Administrator","password");
            CTableColumn[] ttColumns = new CTableColumn[2];
            ttColumns[0] = new CTableColumn();
            ttColumns[0].setName("Number");
            ttColumns[1] = new CTableColumn();
            ttColumns[1].setName("Summary");
            
            CRecordListSoap ttRecords = new CRecordListSoap();
           
           
            CDefect defect = new CDefect();
            defect = test.editDefect(ttCookie, 15, "", false);
            defect.setSummary("Edited Summaries");
            test.saveDefect(ttCookie, defect);
            
            ttRecords = test.getRecordListForTable(ttCookie,"Defect" , "", ttColumns);
            for (int i=0; i<ttRecords.getRecords().length;i++)
            {
                if (ttRecords.getRecords()[i].getRow()[0].getValue().toString().equals("15"))
                {
                    
                    System.out.println(ttRecords.getRecords()[i].getRow()[0].getValue().toString());
                    System.out.println(ttRecords.getRecords()[i].getRow()[1].getValue().toString());
                    
                }
                
                
            }
            
            
            
            
            
            
         }
        catch (RemoteException ex) {
            Logger.getLogger(Main.class.getName()).log(Level.SEVERE, null, ex);
        }         
        //catch(javax.xml.rpc.ServiceException ex)
       //  {
	//    java.util.logging.Logger.getLogger(Ttsoapcgi.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
      //   }
         //catch (MalformedURLException ex) {
          //      Logger.getLogger(Main.class.getName()).log(Level.SEVERE, null, ex);
        // }
        
        
    }
     private static TtsoapcgiPortType_Stub createProxy() {
          // Note: MyHelloService_Impl is implementation-specific.
          return (TtsoapcgiPortType_Stub)(new Ttsoapcgi_Impl().getTtsoapcgi());
      }
&*/

}
